/* deque (Double Ended Queue)
 * Coada cu doua capete:
 *   - suporta 4 operatii rapide: 
 *       - push_back(x), pop_back();
 *       - push_front(x),pop_front() 
 *          
 */ 

#include <iostream>
#include <deque>
#include <string>
using namespace std;


int main()
{
	deque<int> Q; // declar o coada vida
	
	Q.push_back(10); Q.push_back(20); Q.push_back(30); Q.push_back(40); 
	
	while (!Q.empty())
	{
		cout << Q.front() << ' ';
		Q.pop_front();
	}
	
	return 0;
}

