/* deque (Double Ended Queue)
 * Coada cu doua capete:
 *   - suporta 4 operatii rapide: 
 *       - push_back(x), pop_back();
 *       - push_front(x),pop_front() 
 *          
 */ 

#include <iostream>
#include <deque>
#include <string>
using namespace std;


int main()
{
	deque<int> Q; // declar o coada vida
	
	Q.push_back(10); Q.push_back(20); Q.push_back(30); Q.push_back(40); 
	
	for (size_t i = 0; i < Q.size(); ++i)
	{
		cout << Q[i] << ' ';
	}
	
	cout << '\n';
	
	for (deque<int>::iterator it = Q.begin(); it != Q.end(); ++it)
		cout << *it << ' ';
	cout << '\n';
	
	for (auto it = Q.begin(); it != Q.end(); ++it)
		cout << *it << ' ';
	cout << '\n';
	
	// Range Based for Loop (ciclul for pentru intervale)
	for (int x : Q)
		cout << x << ' ';
	
	return 0;
}

