// O(n * k)
#include <fstream>
#include <deque>
#include <vector>
using namespace std;

const int Inf = 3e4 + 1;

ifstream fin("vila2.in");
ofstream fout("vila2.out");

// v[1]  v[2] v[3] v[4] v[5]
//              j         i        

int main()
{
	int n, k;
	int dif_max = 0;
	
	fin >> n >> k;
	vector<int> v(n + 1); // v[0] ... v[n]
	
	for (int i = 1; i <= n; ++i)
	{
		fin >> v[i];
		if (i >= k)
		{
			int v_min = Inf, v_max = 0;
			for (int j = i; i - j <= k && j >= 1; --j)
			{
				v_min = min(v_min, v[j]);
				v_max = max(v_max, v[j]);
			}
			
			dif_max = max(dif_max, v_max - v_min);
		}
	}
	
	fout << dif_max;
	
	return 0;
}

